Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17519)
@@ -108,4 +108,6 @@
     </Compile>
     <Compile Include="ViewModels\ArrayValueVM.cs" />
+    <Compile Include="ViewModels\DoubleVMs.cs" />
+    <Compile Include="ViewModels\IntVMs.cs" />
     <Compile Include="ViewModels\JsonItemVMBase.cs" />
     <Compile Include="ViewModels\LookupJsonItemVM.cs" />
@@ -117,4 +119,10 @@
     <Compile Include="ViewModels\StringValueVM.cs" />
     <Compile Include="ViewModels\ValueLookupJsonItemVM.cs" />
+    <Compile Include="Shared\ConcreteItemsRestrictor.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Shared\ConcreteItemsRestrictor.Designer.cs">
+      <DependentUpon>ConcreteItemsRestrictor.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\ExportJsonDialog.cs">
       <SubType>Form</SubType>
@@ -124,4 +132,10 @@
     </Compile>
     <Compile Include="FileManager.cs" />
+    <Compile Include="Views\JsonItemConcreteItemArrayControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\JsonItemConcreteItemArrayControl.Designer.cs">
+      <DependentUpon>JsonItemConcreteItemArrayControl.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\JsonItemMultiValueControl.cs">
       <SubType>UserControl</SubType>
@@ -224,6 +238,12 @@
       <DependentUpon>NumericRangeControl.cs</DependentUpon>
     </EmbeddedResource>
+    <EmbeddedResource Include="Shared\ConcreteItemsRestrictor.resx">
+      <DependentUpon>ConcreteItemsRestrictor.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="Views\ExportJsonDialog.resx">
       <DependentUpon>ExportJsonDialog.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Views\JsonItemConcreteItemArrayControl.resx">
+      <DependentUpon>JsonItemConcreteItemArrayControl.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Views\JsonItemMultiValueControl.resx">
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs	(revision 17519)
@@ -0,0 +1,61 @@
+﻿namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class ConcreteItemsRestrictor {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tableOptions = new System.Windows.Forms.TableLayoutPanel();
+      this.SuspendLayout();
+      // 
+      // tableOptions
+      // 
+      this.tableOptions.AutoScroll = true;
+      this.tableOptions.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.tableOptions.ColumnCount = 2;
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableOptions.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableOptions.Location = new System.Drawing.Point(0, 0);
+      this.tableOptions.Name = "tableOptions";
+      this.tableOptions.RowCount = 1;
+      this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.tableOptions.Size = new System.Drawing.Size(500, 200);
+      this.tableOptions.TabIndex = 13;
+      // 
+      // ConcreteItemsRestrictor
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tableOptions);
+      this.Margin = new System.Windows.Forms.Padding(0);
+      this.Name = "ConcreteItemsRestrictor";
+      this.Size = new System.Drawing.Size(500, 200);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TableLayoutPanel tableOptions;
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs	(revision 17519)
@@ -0,0 +1,59 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class ConcreteItemsRestrictor : UserControl {
+
+    public event Action<object> OnChecked;
+    public event Action<object> OnUnchecked;
+
+    public ConcreteItemsRestrictor() {
+      InitializeComponent();
+    }
+
+    public void Init<T>(IEnumerable<T> objs) {
+      if(objs != null) {
+        foreach(var obj in objs) {
+          SetupOption(obj);
+        }
+      }
+    }
+
+    private void SetupOption(object opt) {
+      AddComboOption(opt);
+      TextBox tb = new TextBox();
+      tb.Text = opt.ToString();
+      tb.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
+      tb.ReadOnly = true;
+
+      CheckBox checkBox = new CheckBox();
+      checkBox.Checked = true;
+
+      checkBox.CheckStateChanged += (o, args) => {
+        if (checkBox.Checked)
+          AddComboOption(opt);
+        else
+          RemoveComboOption(opt);
+      };
+      tableOptions.Controls.Add(checkBox);
+      tableOptions.Controls.Add(tb);
+    }
+
+    private void AddComboOption(object obj) {
+      OnChecked?.Invoke(obj);
+      tableOptions.Refresh();
+    }
+
+    private void RemoveComboOption(object obj) {
+      OnUnchecked?.Invoke(obj);
+      tableOptions.Refresh();
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.resx
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.resx	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.resx	(revision 17519)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17519)
@@ -9,25 +9,11 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
 
-  public class DoubleArrayValueVM : ArrayValueVM<double, DoubleArrayJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleArrayJsonItem);
+  
 
-    protected override double MinTypeValue => double.MinValue;
 
-    protected override double MaxTypeValue => double.MaxValue;
 
-    public override UserControl Control =>
-      new JsonItemDoubleArrayValueControl(this);
-    
-    public override double[] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-  }
-
-  public class IntArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntArrayJsonItem);
+  /*
+  public class StringArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
+    public override Type TargetedJsonItemType => typeof(StringArrayJsonItem);
 
     protected override int MinTypeValue => int.MinValue;
@@ -37,5 +23,5 @@
     public override UserControl Control =>
       new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
-    
+
     public override int[] Value {
       get => Item.Value;
@@ -46,4 +32,6 @@
     }
   }
+  */
+
 
   public abstract class ArrayValueVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>, IArrayJsonItemVM
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17519)
@@ -0,0 +1,62 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public class DoubleRangeVM : RangeVM<double, DoubleRangeJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemRangeControl(this);
+  }
+
+  public class DoubleArrayValueVM : ArrayValueVM<double, DoubleArrayJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemDoubleArrayValueControl(this);
+
+    public override double[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+  }
+
+  public class DoubleMatrixValueVM : MatrixValueVM<double, DoubleMatrixJsonItem> {
+    public override UserControl Control =>
+      new JsonItemDoubleMatrixValueControl(this);
+
+    public override double[][] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+  }
+
+  public class DoubleValueVM : SingleValueVM<double, DoubleJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+       new JsonItemDoubleValueControl(this);
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17519)
@@ -0,0 +1,46 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public class IntArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
+
+    public override int[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+  }
+
+  public class IntRangeVM : RangeVM<int, IntRangeJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemRangeControl(this);
+  }
+
+  public class IntValueVM : SingleValueVM<int, IntJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemIntValueControl(this);
+  }
+
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17519)
@@ -9,5 +9,5 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType>
+  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType> //TODO: RENAME, oder vlt JsonItems direkt als VM?
     where JsonItemType : class, IJsonItem 
   {
@@ -58,5 +58,5 @@
     }
 
-    public abstract Type TargetedJsonItemType { get; }
+    public virtual Type TargetedJsonItemType => typeof(JsonItemType);
     public abstract UserControl Control { get; }
 
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17519)
@@ -8,5 +8,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class LookupJsonItemVM : JsonItemVMBase<LookupJsonItem>, ILookupJsonItemVM {
-    public override Type TargetedJsonItemType => typeof(LookupJsonItem);
 
     public override UserControl Control => new LookupJsonItemControl(this);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17519)
@@ -9,21 +9,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
 
-  public class DoubleMatrixValueVM : MatrixValueVM<double, DoubleMatrixJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleMatrixJsonItem);
-    public override UserControl Control =>
-      new JsonItemDoubleMatrixValueControl(this);
-
-    public override double[][] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-
-    protected override double MinTypeValue => double.MinValue;
-
-    protected override double MaxTypeValue => double.MaxValue;
-  }
 
   public abstract class MatrixValueVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>, IMatrixJsonItemVM
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17519)
@@ -8,26 +8,4 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-
-  public class IntRangeVM : RangeVM<int, IntRangeJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntRangeJsonItem);
-
-    protected override int MinTypeValue => int.MinValue;
-
-    protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
-  }
-
-  public class DoubleRangeVM : RangeVM<double, DoubleRangeJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleRangeJsonItem);
-
-    protected override double MinTypeValue => double.MinValue;
-
-    protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
-  }
 
   public abstract class RangeVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17519)
@@ -8,26 +8,6 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public class IntValueVM : SingleValueVM<int, IntJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntJsonItem);
-
-    protected override int MinTypeValue => int.MinValue;
-    protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemIntValueControl(this);
-  }
-
-  public class DoubleValueVM : SingleValueVM<double, DoubleJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleJsonItem);
-
-    protected override double MinTypeValue => double.MinValue;
-    protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-       new JsonItemDoubleValueControl(this);
-  }
 
   public class BoolValueVM : JsonItemVMBase<BoolJsonItem> {
-    public override Type TargetedJsonItemType => typeof(BoolJsonItem);
 
     public bool Value { 
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17519)
@@ -9,5 +9,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class StringValueVM : JsonItemVMBase<StringJsonItem> {
-    public override Type TargetedJsonItemType => typeof(StringJsonItem);
     public override UserControl Control =>
        new JsonItemValidValuesControl(this);
@@ -37,5 +36,25 @@
       }
     }
+  }
 
+  public class StringArrayVM : JsonItemVMBase<StringArrayJsonItem> {
+    public override UserControl Control =>
+       new JsonItemConcreteItemArrayControl(this);
+
+    public string[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+
+    public IEnumerable<string> Range {
+      get => Item.ConcreteRestrictedItems;
+      set {
+        Item.ConcreteRestrictedItems = value;
+        OnPropertyChange(this, nameof(Range));
+      }
+    }
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs	(revision 17519)
@@ -0,0 +1,122 @@
+﻿namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class JsonItemConcreteItemArrayControl {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.dataGridView = new System.Windows.Forms.DataGridView();
+      this.groupBox2 = new System.Windows.Forms.GroupBox();
+      this.concreteItemsRestrictor = new HeuristicLab.JsonInterface.OptimizerIntegration.ConcreteItemsRestrictor();
+      this.tableLayoutPanel1.SuspendLayout();
+      this.groupBox1.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
+      this.groupBox2.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // tableLayoutPanel1
+      // 
+      this.tableLayoutPanel1.ColumnCount = 1;
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel1.Controls.Add(this.groupBox1, 0, 0);
+      this.tableLayoutPanel1.Controls.Add(this.groupBox2, 0, 1);
+      this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
+      this.tableLayoutPanel1.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel1.Name = "tableLayoutPanel1";
+      this.tableLayoutPanel1.RowCount = 2;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(682, 350);
+      this.tableLayoutPanel1.TabIndex = 0;
+      // 
+      // groupBox1
+      // 
+      this.groupBox1.Controls.Add(this.dataGridView);
+      this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox1.Location = new System.Drawing.Point(0, 0);
+      this.groupBox1.Margin = new System.Windows.Forms.Padding(0);
+      this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Size = new System.Drawing.Size(682, 175);
+      this.groupBox1.TabIndex = 0;
+      this.groupBox1.TabStop = false;
+      this.groupBox1.Text = "Value";
+      // 
+      // dataGridView
+      // 
+      this.dataGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.dataGridView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.dataGridView.Location = new System.Drawing.Point(3, 16);
+      this.dataGridView.Name = "dataGridView";
+      this.dataGridView.Size = new System.Drawing.Size(676, 156);
+      this.dataGridView.TabIndex = 0;
+      this.dataGridView.CellEndEdit += new System.Windows.Forms.DataGridViewCellEventHandler(this.dataGridView_CellEndEdit);
+      this.dataGridView.RowsRemoved += new System.Windows.Forms.DataGridViewRowsRemovedEventHandler(this.dataGridView_RowsRemoved);
+      // 
+      // groupBox2
+      // 
+      this.groupBox2.Controls.Add(this.concreteItemsRestrictor);
+      this.groupBox2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox2.Location = new System.Drawing.Point(0, 175);
+      this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
+      this.groupBox2.Name = "groupBox2";
+      this.groupBox2.Size = new System.Drawing.Size(682, 175);
+      this.groupBox2.TabIndex = 1;
+      this.groupBox2.TabStop = false;
+      this.groupBox2.Text = "Range";
+      // 
+      // concreteItemsRestrictor
+      // 
+      this.concreteItemsRestrictor.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.concreteItemsRestrictor.Location = new System.Drawing.Point(3, 16);
+      this.concreteItemsRestrictor.Margin = new System.Windows.Forms.Padding(0);
+      this.concreteItemsRestrictor.Name = "concreteItemsRestrictor";
+      this.concreteItemsRestrictor.Size = new System.Drawing.Size(676, 156);
+      this.concreteItemsRestrictor.TabIndex = 0;
+      // 
+      // JsonItemConcreteItemArrayControl
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tableLayoutPanel1);
+      this.Margin = new System.Windows.Forms.Padding(0);
+      this.Name = "JsonItemConcreteItemArrayControl";
+      this.Size = new System.Drawing.Size(682, 350);
+      this.tableLayoutPanel1.ResumeLayout(false);
+      this.groupBox1.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).EndInit();
+      this.groupBox2.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private System.Windows.Forms.GroupBox groupBox1;
+    private System.Windows.Forms.DataGridView dataGridView;
+    private System.Windows.Forms.GroupBox groupBox2;
+    private ConcreteItemsRestrictor concreteItemsRestrictor;
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.cs	(revision 17519)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class JsonItemConcreteItemArrayControl : UserControl {
+    private StringArrayVM VM { get; set; }
+    private DataGridViewComboBoxColumn ComboBox { get; set; }
+    public JsonItemConcreteItemArrayControl(StringArrayVM vm) {
+      InitializeComponent();
+      dataGridView.AllowUserToDeleteRows = true;
+      VM = vm;
+      if (VM.Item.ConcreteRestrictedItems != null) {
+        ComboBox = new DataGridViewComboBoxColumn();
+        dataGridView.Columns.Add(ComboBox);
+        concreteItemsRestrictor.OnChecked += AddComboOption;
+        concreteItemsRestrictor.OnUnchecked += RemoveComboOption;
+        concreteItemsRestrictor.Init(VM.Item.ConcreteRestrictedItems);
+      } else {
+        dataGridView.AllowUserToAddRows = true;
+        dataGridView.Columns.Add(new DataGridViewTextBoxColumn());
+        groupBox2.Visible = false;
+        tableLayoutPanel1.RowStyles[0].SizeType = SizeType.Percent;
+        tableLayoutPanel1.RowStyles[0].Height = 100.0f;
+      }
+      if(VM.Value != null) {
+        foreach (var val in VM.Value) {
+          dataGridView.Rows.Add(val);
+        }
+      }
+    }
+
+    private void AddComboOption(object opt) {
+      ComboBox.Items.Add(opt);
+      IList<string> items = new List<string>();
+      foreach (var i in ComboBox.Items) {
+        items.Add((string)i);
+      }
+      VM.Range = items;
+      dataGridView.AllowUserToAddRows = true;
+    }
+
+    private void RemoveComboOption(object opt) {
+      ComboBox.Items.Remove(opt);
+      IList<string> items = new List<string>();
+      foreach (var i in ComboBox.Items) {
+        items.Add((string)i);
+      }
+      VM.Range = items;
+      
+      if (VM.Range.Count() <= 0) {
+        dataGridView.Rows.Clear();
+        dataGridView.AllowUserToAddRows = false;
+      }
+    }
+
+    private void BuildValue() {
+      IList<string> list = new List<string>();
+      for (int r = 0; r < dataGridView.Rows.Count; ++r) {
+        var value = dataGridView[0, r].Value;
+        if(value != null)
+          list.Add((string)value);
+      }
+      VM.Value = list.ToArray();
+    }
+    
+    private void dataGridView_RowsRemoved(object sender, DataGridViewRowsRemovedEventArgs e) {
+      BuildValue();
+    }
+
+    private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e) {
+      BuildValue();
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.resx
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.resx	(revision 17519)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.resx	(revision 17519)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemMultiValueControl.cs	(revision 17519)
@@ -80,5 +80,5 @@
       int cols = matrix.Length;
       int rows = matrix.Max(x => x.Length);
-
+      
       Matrix = matrix;
       Columns = cols;
@@ -250,5 +250,4 @@
                                             typeof(T),
                                             System.Globalization.CultureInfo.InvariantCulture);
-      //Save(Matrix[e.ColumnIndex][e.RowIndex], e.ColumnIndex, e.RowIndex);
       Save();
     }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17519)
@@ -25,8 +25,8 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      this.tableOptions = new System.Windows.Forms.TableLayoutPanel();
       this.comboBoxValues = new System.Windows.Forms.ComboBox();
       this.label2 = new System.Windows.Forms.Label();
       this.groupBoxRange = new System.Windows.Forms.GroupBox();
+      this.concreteItemsRestrictor = new HeuristicLab.JsonInterface.OptimizerIntegration.ConcreteItemsRestrictor();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
       this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
@@ -37,20 +37,4 @@
       this.tableLayoutPanel2.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // tableOptions
-      // 
-      this.tableOptions.AutoScroll = true;
-      this.tableOptions.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.tableOptions.ColumnCount = 2;
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
-      this.tableOptions.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableOptions.Location = new System.Drawing.Point(3, 16);
-      this.tableOptions.Name = "tableOptions";
-      this.tableOptions.RowCount = 1;
-      this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableOptions.Size = new System.Drawing.Size(494, 217);
-      this.tableOptions.TabIndex = 12;
       // 
       // comboBoxValues
@@ -79,5 +63,5 @@
       // groupBoxRange
       // 
-      this.groupBoxRange.Controls.Add(this.tableOptions);
+      this.groupBoxRange.Controls.Add(this.concreteItemsRestrictor);
       this.groupBoxRange.Dock = System.Windows.Forms.DockStyle.Fill;
       this.groupBoxRange.Location = new System.Drawing.Point(0, 22);
@@ -88,4 +72,13 @@
       this.groupBoxRange.TabStop = false;
       this.groupBoxRange.Text = "Range";
+      // 
+      // concreteItemsRestrictor
+      // 
+      this.concreteItemsRestrictor.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.concreteItemsRestrictor.Location = new System.Drawing.Point(3, 16);
+      this.concreteItemsRestrictor.Margin = new System.Windows.Forms.Padding(0);
+      this.concreteItemsRestrictor.Name = "concreteItemsRestrictor";
+      this.concreteItemsRestrictor.Size = new System.Drawing.Size(494, 217);
+      this.concreteItemsRestrictor.TabIndex = 0;
       // 
       // errorProvider
@@ -122,5 +115,5 @@
       this.tableLayoutPanel2.RowCount = 1;
       this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 22F));
       this.tableLayoutPanel2.Size = new System.Drawing.Size(500, 22);
       this.tableLayoutPanel2.TabIndex = 19;
@@ -146,5 +139,4 @@
 
     #endregion
-    private System.Windows.Forms.TableLayoutPanel tableOptions;
     private System.Windows.Forms.ComboBox comboBoxValues;
     private System.Windows.Forms.Label label2;
@@ -153,4 +145,5 @@
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private ConcreteItemsRestrictor concreteItemsRestrictor;
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17485)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17519)
@@ -1,10 +1,5 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
+﻿using System.Collections.Generic;
 using System.Drawing;
-using System.Data;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 using System.Windows.Forms;
 
@@ -18,44 +13,26 @@
       VM = vm;
       if (VM.Item.ConcreteRestrictedItems != null) {
-        foreach (var i in VM.Item.ConcreteRestrictedItems)
-          SetupOption(i);
+        concreteItemsRestrictor.OnChecked += AddComboOption;
+        concreteItemsRestrictor.OnUnchecked += RemoveComboOption;
+        concreteItemsRestrictor.Init(VM.Item.ConcreteRestrictedItems);
         comboBoxValues.DataBindings.Add("SelectedItem", VM, nameof(StringValueVM.Value));
       } else {
-        comboBoxValues.Hide();
         groupBoxRange.Hide();
         TextBox tb = new TextBox();
-        this.Controls.Add(tb);
+        tableLayoutPanel2.Controls.Remove(comboBoxValues);
+        tableLayoutPanel2.Controls.Add(tb, 1, 0);
+
         tb.Location = comboBoxValues.Location;
-        tb.Size = comboBoxValues.Size;
-        tb.Anchor = comboBoxValues.Anchor;
-        tb.Dock = comboBoxValues.Dock;
+        tb.Margin = new Padding(0);
+        tb.Size = new Size(comboBoxValues.Size.Width, 20);
+        tb.Anchor = AnchorStyles.Top | AnchorStyles.Left;
+        tb.Dock = DockStyle.Fill;
+
         tb.DataBindings.Add("Text", VM, nameof(StringValueVM.Value));
         tb.Show();
       }
     }
-    
-    private void SetupOption(string opt) {
-      AddComboOption(opt);
-      TextBox tb = new TextBox();
-      tb.Text = opt;
-      //tb.Size = new Size()
-      tb.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
-      //tb.Dock = DockStyle.Right | DockStyle.Left;
-      tb.ReadOnly = true;
 
-      CheckBox checkBox = new CheckBox();
-      checkBox.Checked = true;
-      
-      checkBox.CheckStateChanged += (o, args) => {
-        if (checkBox.Checked)
-          AddComboOption(opt);
-        else
-          RemoveComboOption(opt);
-      };
-      tableOptions.Controls.Add(checkBox);
-      tableOptions.Controls.Add(tb);
-    }
-
-    private void AddComboOption(string opt) {
+    private void AddComboOption(object opt) {
       comboBoxValues.Items.Add(opt);
       IList<string> items = new List<string>();
@@ -63,10 +40,9 @@
         items.Add((string)i);
       }
-      ((StringValueVM)VM).Range = items;
+      VM.Range = items;
       comboBoxValues.Enabled = true;
-      tableOptions.Refresh();
     }
 
-    private void RemoveComboOption(string opt) {
+    private void RemoveComboOption(object opt) {
       comboBoxValues.Items.Remove(opt);
       IList<string> items = new List<string>();
@@ -74,10 +50,9 @@
         items.Add((string)i);
       }
-      ((StringValueVM)VM).Range = items;
-      if (((StringValueVM)VM).Range.Count() <= 0) {
+      VM.Range = items;
+      if (VM.Range.Count() <= 0) {
         comboBoxValues.Enabled = false;
         comboBoxValues.SelectedIndex = -1;
       }
-      tableOptions.Refresh();
     }
   }
